/**
* DevExtreme (data/custom_store.d.ts)
* Version: 21.1.0 (build 21016-0316)
* Build date: Sat Jan 16 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../jquery_augmentation';

import Store, {
    StoreOptions
} from './abstract_store';

import {
    LoadOptions
} from './load_options';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface CustomStoreOptions extends StoreOptions<CustomStore> {
    /**
     */
    byKey?: ((key: any | string | number) => Promise<any> | JQueryPromise<any>);
    /**
     */
    cacheRawData?: boolean;
    /**
     */
    insert?: ((values: any) => Promise<any> | JQueryPromise<any>);
    /**
     */
    load?: ((options: LoadOptions) => Promise<any> | JQueryPromise<any> | Array<any>);
    /**
     */
    loadMode?: 'processed' | 'raw';
    /**
     */
    remove?: ((key: any | string | number) => Promise<void> | JQueryPromise<void>);
    /**
     */
    totalCount?: ((loadOptions: { filter?: any, group?: any }) => Promise<number> | JQueryPromise<number>);
    /**
     */
    update?: ((key: any | string | number, values: any) => Promise<any> | JQueryPromise<any>);
    /**
     */
    useDefaultSearch?: boolean;
}
/**
 */
export default class CustomStore extends Store {
    constructor(options?: CustomStoreOptions)
    /**
     */
    clearRawDataCache(): void;
}
