/**
* DevExtreme (data/odata/context.d.ts)
* Version: 21.1.0 (build 21016-0316)
* Build date: Sat Jan 16 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../../jquery_augmentation';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface ODataContextOptions {
    /**
     */
    beforeSend?: ((options: { url?: string, async?: boolean, method?: string, timeout?: number, params?: any, payload?: any, headers?: any }) => any);
    /**
     */
    deserializeDates?: boolean;
    /**
     */
    entities?: any;
    /**
     */
    errorHandler?: ((e: { httpStatus?: number, errorDetails?: any, requestOptions?: any }) => any);
    /**
     */
    filterToLower?: boolean;
    /**
     */
    jsonp?: boolean;
    /**
     */
    url?: string;
    /**
     */
    version?: number;
    /**
     */
    withCredentials?: boolean;
}
/**
 */
export default class ODataContext {
    constructor(options?: ODataContextOptions)
    /**
     */
    get(operationName: string, params: any): Promise<any> & JQueryPromise<any>;
    /**
     */
    invoke(operationName: string, params: any, httpMethod: any): Promise<void> & JQueryPromise<void>;
    /**
     */
    objectLink(entityAlias: string, key: any | string | number): any;
}
