/**
* DevExtreme (pdf_exporter.d.ts)
* Version: 21.1.0 (build 21016-0316)
* Build date: Sat Jan 16 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import dxDataGrid, { dxDataGridColumn } from './ui/data_grid';
import { ExportLoadPanel } from './exporter/export_load_panel';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface PdfDataGridCell {
    /**
     */
    column?: dxDataGridColumn;
    /**
     */
    data?: any;
    /**
     */
    groupIndex?: number;
    /**
     */
    groupSummaryItems?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      name?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      value?: any
    }>;
    /**
     */
    rowType?: string;
    /**
     */
    totalSummaryItemName?: string;
    /**
     */
    value?: any;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface PdfExportDataGridProps {
     /**
      */
    jsPDFDocument?: object;
     /**
      */
    autoTableOptions?: object;
    /**
     */
    component?: dxDataGrid;
    /**
     */
    selectedRowsOnly?: boolean;
    /**
     */
    keepColumnWidths?: boolean;
    /**
     */
    customizeCell?: ((options: { gridCell?: PdfDataGridCell, pdfCell?: any}) => any);
     /**
      */
    loadPanel?: ExportLoadPanel;
}

/**
 * [tags] ctp Exports grid data to a PDF file.
 */
export function exportDataGrid(options: PdfExportDataGridProps): Promise<void> & JQueryPromise<void>;
