/**
 * DevExtreme (renovation/ui/scroll_view/scroll_view_props.js)
 * Version: 21.1.0 (build 21016-0316)
 * Build date: Sat Jan 16 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.ScrollViewPropsType = exports.ScrollViewProps = void 0;
var _scrollable_props = require("./scrollable_props");
var _base_props = _interopRequireDefault(require("../../utils/base_props"));

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter((function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            }))
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach((function(key) {
                _defineProperty(target, key, source[key])
            }))
        } else if (Object.getOwnPropertyDescriptors) {
            Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
        } else {
            ownKeys(Object(source)).forEach((function(key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
            }))
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}
var ScrollViewProps = _objectSpread({}, _scrollable_props.ScrollableProps);
exports.ScrollViewProps = ScrollViewProps;
var ScrollViewPropsType = {
    useNative: ScrollViewProps.useNative,
    direction: ScrollViewProps.direction,
    showScrollbar: ScrollViewProps.showScrollbar,
    scrollByThumb: ScrollViewProps.scrollByThumb,
    useSimulatedScrollbar: ScrollViewProps.useSimulatedScrollbar,
    pushBackValue: ScrollViewProps.pushBackValue,
    bounceEnabled: ScrollViewProps.bounceEnabled,
    scrollByContent: ScrollViewProps.scrollByContent,
    inertiaEnabled: ScrollViewProps.inertiaEnabled,
    updateManually: ScrollViewProps.updateManually,
    useKeyboard: ScrollViewProps.useKeyboard,
    forceGeneratePockets: ScrollViewProps.forceGeneratePockets,
    needScrollViewContentWrapper: ScrollViewProps.needScrollViewContentWrapper,
    disabled: _base_props.default.disabled
};
exports.ScrollViewPropsType = ScrollViewPropsType;
