/**
 * DevExtreme (renovation/ui/scroll_view/topPocket.js)
 * Version: 21.1.0 (build 21016-0316)
 * Build date: Sat Jan 16 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.TopPocket = TopPocket;
exports.viewFunction = void 0;
var _devices = _interopRequireDefault(require("../../../core/devices"));
var _type = require("../../../core/utils/type");
var _message = _interopRequireDefault(require("../../../localization/message"));
var _topPocket_props = require("./topPocket_props");
var Preact = _interopRequireWildcard(require("preact"));
var _hooks = require("preact/hooks");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            default: obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter((function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            }))
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach((function(key) {
                _defineProperty(target, key, source[key])
            }))
        } else if (Object.getOwnPropertyDescriptors) {
            Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
        } else {
            ownKeys(Object(source)).forEach((function(key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
            }))
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest()
}

function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")
}

function _unsupportedIterableToArray(o, minLen) {
    if (!o) {
        return
    }
    if ("string" === typeof o) {
        return _arrayLikeToArray(o, minLen)
    }
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if ("Object" === n && o.constructor) {
        n = o.constructor.name
    }
    if ("Map" === n || "Set" === n) {
        return Array.from(o)
    }
    if ("Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) {
        return _arrayLikeToArray(o, minLen)
    }
}

function _arrayLikeToArray(arr, len) {
    if (null == len || len > arr.length) {
        len = arr.length
    }
    for (var i = 0, arr2 = new Array(len); i < len; i++) {
        arr2[i] = arr[i]
    }
    return arr2
}

function _iterableToArrayLimit(arr, i) {
    if ("undefined" === typeof Symbol || !(Symbol.iterator in Object(arr))) {
        return
    }
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = void 0;
    try {
        for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done); _n = true) {
            _arr.push(_s.value);
            if (i && _arr.length === i) {
                break
            }
        }
    } catch (err) {
        _d = true;
        _e = err
    } finally {
        try {
            if (!_n && null != _i.return) {
                _i.return()
            }
        } finally {
            if (_d) {
                throw _e
            }
        }
    }
    return _arr
}

function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) {
        return arr
    }
}
var SCROLLVIEW_TOP_POCKET_CLASS = "dx-scrollview-top-pocket";
var SCROLLVIEW_PULLDOWN = "dx-scrollview-pull-down";
var SCROLLVIEW_PULLDOWN_IMAGE_CLASS = "dx-scrollview-pull-down-image";
var SCROLLVIEW_PULLDOWN_INDICATOR_CLASS = "dx-scrollview-pull-down-indicator";
var SCROLLVIEW_PULLDOWN_TEXT_CLASS = "dx-scrollview-pull-down-text";
var SCROLLVIEW_PULLDOWN_VISIBLE_TEXT_CLASS = "dx-scrollview-pull-down-text-visible";

function getVisibleClass(currentState, expectedState) {
    return currentState === expectedState ? SCROLLVIEW_PULLDOWN_VISIBLE_TEXT_CLASS : void 0
}
var viewFunction = function(viewModel) {
    var pocketState = viewModel.pocketState,
        pulledDownText = viewModel.pulledDownText,
        pullingDownText = viewModel.pullingDownText,
        refreshStrategy = viewModel.refreshStrategy,
        refreshingText = viewModel.refreshingText;
    return Preact.h("div", {
        className: SCROLLVIEW_TOP_POCKET_CLASS
    }, Preact.h("div", {
        className: SCROLLVIEW_PULLDOWN
    }, Preact.h("div", {
        className: SCROLLVIEW_PULLDOWN_IMAGE_CLASS
    }), Preact.h("div", {
        className: SCROLLVIEW_PULLDOWN_INDICATOR_CLASS
    }), Preact.h("div", {
        className: SCROLLVIEW_PULLDOWN_TEXT_CLASS
    }, "swipeDown" !== refreshStrategy && Preact.h(Preact.Fragment, null, Preact.h("div", {
        className: getVisibleClass(pocketState, _topPocket_props.TopPocketState.STATE_RELEASED)
    }, pullingDownText), Preact.h("div", {
        className: getVisibleClass(pocketState, _topPocket_props.TopPocketState.STATE_READY)
    }, pulledDownText), Preact.h("div", {
        className: getVisibleClass(pocketState, _topPocket_props.TopPocketState.STATE_REFRESHING)
    }, refreshingText)))))
};
exports.viewFunction = viewFunction;

function TopPocket(props) {
    var _useState = (0, _hooks.useState)(_topPocket_props.TopPocketState.STATE_RELEASED),
        _useState2 = _slicedToArray(_useState, 2),
        __state_pocketState = _useState2[0];
    _useState2[1];
    var __refreshStrategy = (0, _hooks.useCallback)((function() {
        return props.refreshStrategy || ("android" === _devices.default.real().platform ? "swipeDown" : "pullDown")
    }), [props.refreshStrategy]);
    var __pullingDownText = (0, _hooks.useCallback)((function() {
        var pullingDownText = props.pullingDownText;
        if ((0, _type.isDefined)(pullingDownText)) {
            return pullingDownText
        }
        return _message.default.format("dxScrollView-pullingDownText")
    }), [props.pullingDownText]);
    var __pulledDownText = (0, _hooks.useCallback)((function() {
        var pulledDownText = props.pulledDownText;
        if ((0, _type.isDefined)(pulledDownText)) {
            return pulledDownText
        }
        return _message.default.format("dxScrollView-pulledDownText")
    }), [props.pulledDownText]);
    var __refreshingText = (0, _hooks.useCallback)((function() {
        var refreshingText = props.refreshingText;
        if ((0, _type.isDefined)(refreshingText)) {
            return refreshingText
        }
        return _message.default.format("dxScrollView-refreshingText")
    }), [props.refreshingText]);
    var __restAttributes = (0, _hooks.useCallback)((function() {
        props.pulledDownText, props.pullingDownText, props.refreshStrategy, props.refreshingText;
        var restProps = _objectWithoutProperties(props, ["pulledDownText", "pullingDownText", "refreshStrategy", "refreshingText"]);
        return restProps
    }), [props]);
    return viewFunction({
        props: _objectSpread({}, props),
        pocketState: __state_pocketState,
        refreshStrategy: __refreshStrategy(),
        pullingDownText: __pullingDownText(),
        pulledDownText: __pulledDownText(),
        refreshingText: __refreshingText(),
        restAttributes: __restAttributes()
    })
}
TopPocket.defaultProps = _objectSpread({}, _topPocket_props.TopPocketProps);
