/**
* DevExtreme (renovation/ui/scroll_view/types.d.ts)
* Version: 21.1.0 (build 21016-0316)
* Build date: Sat Jan 16 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface ScrollableBoundary {
  reachedBottom: boolean;
  reachedLeft: boolean;
  reachedRight: boolean;
  reachedTop: boolean;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface ScrollEventArgs extends Partial<ScrollableBoundary> {
  event: Event;
  scrollOffset: ScrollableLocation;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type ScrollableShowScrollbar = 'onScroll' | 'onHover' | 'always' | 'never';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type ScrollableDirection = 'both' | 'horizontal' | 'vertical';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type RefreshStrategy = 'pullDown' | 'swipeDown' | 'simulated';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface ScrollableLocation {
  top: number;
  left: number;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface ScrollOffset {
  top: number;
  left: number;
  bottom: number;
  right: number;
}
