/**
* DevExtreme (ui/drawer.d.ts)
* Version: 21.1.0 (build 21016-0316)
* Build date: Sat Jan 16 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../jquery_augmentation';

import {
    dxElement
} from '../core/element';

import {
    template
} from '../core/templates/template';

import {
    event
} from '../events/index';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDrawerOptions extends WidgetOptions<dxDrawer> {
    /**
     */
    animationDuration?: number;
    /**
     */
    animationEnabled?: boolean;
    /**
     */
    closeOnOutsideClick?: boolean | ((event: event) => boolean);
    /**
     */
    maxSize?: number;
    /**
     */
    minSize?: number;
    /**
     */
    opened?: boolean;
    /**
     */
    openedStateMode?: 'overlap' | 'shrink' | 'push';
    /**
     */
    position?: 'left' | 'right' | 'top' | 'bottom' | 'before' | 'after';
    /**
     */
    revealMode?: 'slide' | 'expand';
    /**
     */
    shading?: boolean;
    /**
     * @deprecated
     */
    target?: string | Element | JQuery;
    /**
     */
    template?: template | ((Element: dxElement) => any);
}
/**
 */
export default class dxDrawer extends Widget {
    constructor(element: Element, options?: dxDrawerOptions)
    constructor(element: JQuery, options?: dxDrawerOptions)
    /**
     */
    content(): dxElement;
    /**
     */
    hide(): Promise<void> & JQueryPromise<void>;
    /**
     */
    show(): Promise<void> & JQueryPromise<void>;
    /**
     */
    toggle(): Promise<void> & JQueryPromise<void>;
}

declare global {
interface JQuery {
    dxDrawer(): JQuery;
    dxDrawer(options: "instance"): dxDrawer;
    dxDrawer(options: string): any;
    dxDrawer(options: string, ...params: any[]): any;
    dxDrawer(options: dxDrawerOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxDrawerOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxDrawerOptions;
