/**
* DevExtreme (ui/editor/editor.d.ts)
* Version: 21.1.0 (build 21016-0316)
* Build date: Sat Jan 16 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../../jquery_augmentation';

import {
    dxElement
} from '../../core/element';

import {
    event
} from '../../events/index';

import Widget, {
    WidgetOptions
} from '../widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface EditorOptions<T = Editor> extends WidgetOptions<T> {
    /**
     */
    isValid?: boolean;
    /**
     */
    onValueChanged?: ((e: { component?: T, element?: dxElement, model?: any, value?: any, previousValue?: any, event?: event }) => any);
    /**
     */
    readOnly?: boolean;
    /**
     */
    validationError?: any;
    /**
     */
    validationErrors?: Array<any>;
    /**
     */
    validationMessageMode?: 'always' | 'auto';
    /**
     */
    validationStatus?: 'valid' | 'invalid' | 'pending';
    /**
     */
    value?: any;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class Editor extends Widget {
    constructor(element: Element, options?: EditorOptions)
    constructor(element: JQuery, options?: EditorOptions)
    /**
     */
    reset(): void;
}
