/**
* DevExtreme (ui/gallery.d.ts)
* Version: 21.1.0 (build 21016-0316)
* Build date: Sat Jan 16 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../jquery_augmentation';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import CollectionWidget, {
    CollectionWidgetItem,
    CollectionWidgetOptions
} from './collection/ui.collection_widget.base';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxGalleryOptions extends CollectionWidgetOptions<dxGallery> {
    /**
     */
    animationDuration?: number;
    /**
     */
    animationEnabled?: boolean;
    /**
     */
    dataSource?: string | Array<string | dxGalleryItem | any> | DataSource | DataSourceOptions;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    indicatorEnabled?: boolean;
    /**
     */
    initialItemWidth?: number;
    /**
     */
    items?: Array<string | dxGalleryItem | any>;
    /**
     */
    loop?: boolean;
    /**
     */
    noDataText?: string;
    /**
     */
    selectedIndex?: number;
    /**
     */
    showIndicator?: boolean;
    /**
     */
    showNavButtons?: boolean;
    /**
     */
    slideshowDelay?: number;
    /**
     */
    stretchImages?: boolean;
    /**
     */
    swipeEnabled?: boolean;
    /**
     */
    wrapAround?: boolean;
}
/**
 */
export default class dxGallery extends CollectionWidget {
    constructor(element: Element, options?: dxGalleryOptions)
    constructor(element: JQuery, options?: dxGalleryOptions)
    /**
     */
    goToItem(itemIndex: number, animation: boolean): Promise<void> & JQueryPromise<void>;
    /**
     */
    nextItem(animation: boolean): Promise<void> & JQueryPromise<void>;
    /**
     */
    prevItem(animation: boolean): Promise<void> & JQueryPromise<void>;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxGalleryItem extends CollectionWidgetItem {
    /**
     */
    imageAlt?: string;
    /**
     */
    imageSrc?: string;
}

declare global {
interface JQuery {
    dxGallery(): JQuery;
    dxGallery(options: "instance"): dxGallery;
    dxGallery(options: string): any;
    dxGallery(options: string, ...params: any[]): any;
    dxGallery(options: dxGalleryOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxGalleryOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxGalleryOptions;
