/**
 * DevExtreme (ui/scheduler/appointments/appointment.js)
 * Version: 21.1.0 (build 21016-0316)
 * Build date: Sat Jan 16 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.default = void 0;
var _renderer = _interopRequireDefault(require("../../../core/renderer"));
var _events_engine = _interopRequireDefault(require("../../../events/core/events_engine"));
var _translator = require("../../../animation/translator");
var _recurrence = require("../recurrence");
var _extend = require("../../../core/utils/extend");
var _component_registrator = _interopRequireDefault(require("../../../core/component_registrator"));
var _ui = require("../../tooltip/ui.tooltip");
var _index = require("../../../events/utils/index");
var _pointer = _interopRequireDefault(require("../../../events/pointer"));
var _dom_component = _interopRequireDefault(require("../../../core/dom_component"));
var _resizable = _interopRequireDefault(require("../../resizable"));
var _message = _interopRequireDefault(require("../../../localization/message"));
var _date = _interopRequireDefault(require("../../../localization/date"));
var _constants = require("../constants");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    return Constructor
}

function _get(target, property, receiver) {
    if ("undefined" !== typeof Reflect && Reflect.get) {
        _get = Reflect.get
    } else {
        _get = function(target, property, receiver) {
            var base = _superPropBase(target, property);
            if (!base) {
                return
            }
            var desc = Object.getOwnPropertyDescriptor(base, property);
            if (desc.get) {
                return desc.get.call(receiver)
            }
            return desc.value
        }
    }
    return _get(target, property, receiver || target)
}

function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
        object = _getPrototypeOf(object);
        if (null === object) {
            break
        }
    }
    return object
}

function _inherits(subClass, superClass) {
    if ("function" !== typeof superClass && null !== superClass) {
        throw new TypeError("Super expression must either be null or a function")
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) {
        _setPrototypeOf(subClass, superClass)
    }
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}

function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function() {
        var result, Super = _getPrototypeOf(Derived);
        if (hasNativeReflectConstruct) {
            var NewTarget = _getPrototypeOf(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget)
        } else {
            result = Super.apply(this, arguments)
        }
        return _possibleConstructorReturn(this, result)
    }
}

function _possibleConstructorReturn(self, call) {
    if (call && ("object" === _typeof(call) || "function" === typeof call)) {
        return call
    }
    return _assertThisInitialized(self)
}

function _assertThisInitialized(self) {
    if (void 0 === self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called")
    }
    return self
}

function _isNativeReflectConstruct() {
    if ("undefined" === typeof Reflect || !Reflect.construct) {
        return false
    }
    if (Reflect.construct.sham) {
        return false
    }
    if ("function" === typeof Proxy) {
        return true
    }
    try {
        Date.prototype.toString.call(Reflect.construct(Date, [], (function() {})));
        return true
    } catch (e) {
        return false
    }
}

function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
        return o.__proto__ || Object.getPrototypeOf(o)
    };
    return _getPrototypeOf(o)
}
var DEFAULT_HORIZONTAL_HANDLES = "left right";
var DEFAULT_VERTICAL_HANDLES = "top bottom";
var REDUCED_APPOINTMENT_POINTERENTER_EVENT_NAME = (0, _index.addNamespace)(_pointer.default.enter, "dxSchedulerAppointment");
var REDUCED_APPOINTMENT_POINTERLEAVE_EVENT_NAME = (0, _index.addNamespace)(_pointer.default.leave, "dxSchedulerAppointment");
var Appointment = function(_DOMComponent) {
    _inherits(Appointment, _DOMComponent);
    var _super = _createSuper(Appointment);

    function Appointment() {
        _classCallCheck(this, Appointment);
        return _super.apply(this, arguments)
    }
    _createClass(Appointment, [{
        key: "_getDefaultOptions",
        value: function() {
            return (0, _extend.extend)(_get(_getPrototypeOf(Appointment.prototype), "_getDefaultOptions", this).call(this), {
                data: {},
                groupIndex: -1,
                geometry: {
                    top: 0,
                    left: 0,
                    width: 0,
                    height: 0
                },
                allowDrag: true,
                allowResize: true,
                reduced: null,
                isCompact: false,
                direction: "vertical",
                resizableConfig: {},
                cellHeight: 0,
                cellWidth: 0,
                isDragSource: false
            })
        }
    }, {
        key: "notifyObserver",
        value: function(subject, args) {
            var observer = this.option("observer");
            if (observer) {
                observer.fire(subject, args)
            }
        }
    }, {
        key: "invoke",
        value: function() {
            var observer = this.option("observer");
            if (observer) {
                return observer.fire.apply(observer, arguments)
            }
        }
    }, {
        key: "_optionChanged",
        value: function(args) {
            switch (args.name) {
                case "data":
                case "groupIndex":
                case "geometry":
                case "allowDrag":
                case "allowResize":
                case "reduced":
                case "sortedIndex":
                case "isCompact":
                case "direction":
                case "resizableConfig":
                case "cellHeight":
                case "cellWidth":
                    this._invalidate();
                    break;
                case "isDragSource":
                    this._renderDragSourceClass();
                    break;
                default:
                    _get(_getPrototypeOf(Appointment.prototype), "_optionChanged", this).call(this, args)
            }
        }
    }, {
        key: "_getHorizontalResizingRule",
        value: function() {
            var reducedHandles = {
                head: this.option("rtlEnabled") ? "right" : "left",
                body: "",
                tail: this.option("rtlEnabled") ? "left" : "right"
            };
            return {
                handles: this.option("reduced") ? reducedHandles[this.option("reduced")] : DEFAULT_HORIZONTAL_HANDLES,
                minHeight: 0,
                minWidth: this.invoke("getCellWidth"),
                step: this.invoke("getResizableStep"),
                roundStepValue: false
            }
        }
    }, {
        key: "_getVerticalResizingRule",
        value: function() {
            var height = this.invoke("getCellHeight");
            return {
                handles: DEFAULT_VERTICAL_HANDLES,
                minWidth: 0,
                minHeight: height,
                step: height,
                roundStepValue: true
            }
        }
    }, {
        key: "_render",
        value: function() {
            var _this = this;
            _get(_getPrototypeOf(Appointment.prototype), "_render", this).call(this);
            this._renderAppointmentGeometry();
            this._renderEmptyClass();
            this._renderReducedAppointment();
            this._renderAllDayClass();
            this._renderDragSourceClass();
            this._renderDirection();
            this.$element().data("dxAppointmentStartDate", this.option("startDate"));
            this.$element().attr("title", this.invoke("getField", "text", this.option("data")));
            this.$element().attr("role", "button");
            this._renderRecurrenceClass();
            this._renderResizable();
            var deferredColor = this.invoke("getAppointmentColor", {
                itemData: this.option("data"),
                groupIndex: this.option("groupIndex")
            });
            deferredColor.done((function(color) {
                return color && _this.$element().css("backgroundColor", color)
            }))
        }
    }, {
        key: "_renderAppointmentGeometry",
        value: function() {
            var geometry = this.option("geometry");
            var $element = this.$element();
            (0, _translator.move)($element, {
                top: geometry.top,
                left: geometry.left
            });
            $element.css({
                width: geometry.width < 0 ? 0 : geometry.width,
                height: geometry.height < 0 ? 0 : geometry.height
            })
        }
    }, {
        key: "_renderEmptyClass",
        value: function() {
            var geometry = this.option("geometry");
            if (geometry.empty || this.option("isCompact")) {
                this.$element().addClass(_constants.EMPTY_APPOINTMENT_CLASS)
            }
        }
    }, {
        key: "_renderReducedAppointment",
        value: function() {
            var reducedPart = this.option("reduced");
            if (!reducedPart) {
                return
            }
            this.$element().toggleClass(_constants.REDUCED_APPOINTMENT_CLASS, true).toggleClass(_constants.REDUCED_APPOINTMENT_PARTS_CLASSES[reducedPart], true);
            this._renderAppointmentReducedIcon()
        }
    }, {
        key: "_renderAppointmentReducedIcon",
        value: function() {
            var $icon = (0, _renderer.default)("<div>").addClass(_constants.REDUCED_APPOINTMENT_ICON).appendTo(this.$element());
            var endDate = this._getEndDate();
            var tooltipLabel = _message.default.format("dxScheduler-editorLabelEndDate");
            var tooltipText = [tooltipLabel, ": ", _date.default.format(endDate, "monthAndDay"), ", ", _date.default.format(endDate, "year")].join("");
            _events_engine.default.off($icon, REDUCED_APPOINTMENT_POINTERENTER_EVENT_NAME);
            _events_engine.default.on($icon, REDUCED_APPOINTMENT_POINTERENTER_EVENT_NAME, (function() {
                (0, _ui.show)({
                    target: $icon,
                    content: tooltipText
                })
            }));
            _events_engine.default.off($icon, REDUCED_APPOINTMENT_POINTERLEAVE_EVENT_NAME);
            _events_engine.default.on($icon, REDUCED_APPOINTMENT_POINTERLEAVE_EVENT_NAME, (function() {
                (0, _ui.hide)()
            }))
        }
    }, {
        key: "_getEndDate",
        value: function() {
            var result = this.invoke("getField", "endDate", this.option("data"));
            if (result) {
                return new Date(result)
            }
            return result
        }
    }, {
        key: "_renderAllDayClass",
        value: function() {
            this.$element().toggleClass(_constants.ALL_DAY_APPOINTMENT_CLASS, !!this.option("allDay"))
        }
    }, {
        key: "_renderDragSourceClass",
        value: function() {
            this.$element().toggleClass(_constants.APPOINTMENT_DRAG_SOURCE_CLASS, !!this.option("isDragSource"))
        }
    }, {
        key: "_renderRecurrenceClass",
        value: function() {
            var rule = this.invoke("getField", "recurrenceRule", this.option("data"));
            if ((0, _recurrence.getRecurrenceProcessor)().isValidRecurrenceRule(rule)) {
                this.$element().addClass(_constants.RECURRENCE_APPOINTMENT_CLASS)
            }
        }
    }, {
        key: "_renderDirection",
        value: function() {
            this.$element().addClass(_constants.DIRECTION_APPOINTMENT_CLASSES[this.option("direction")])
        }
    }, {
        key: "_createResizingConfig",
        value: function() {
            var config = "vertical" === this.option("direction") ? this._getVerticalResizingRule() : this._getHorizontalResizingRule();
            if (!this.invoke("isGroupedByDate")) {
                config.stepPrecision = "strict"
            }
            return config
        }
    }, {
        key: "_renderResizable",
        value: function() {
            if (this.option("allowResize")) {
                this._createComponent(this.$element(), _resizable.default, (0, _extend.extend)(this._createResizingConfig(), this.option("resizableConfig")))
            }
        }
    }, {
        key: "_useTemplates",
        value: function() {
            return false
        }
    }]);
    return Appointment
}(_dom_component.default);
(0, _component_registrator.default)("dxSchedulerAppointment", Appointment);
var _default = Appointment;
exports.default = _default;
module.exports = exports.default;
